execute as @p[tag=hold_pos] run function fnf:transitions

# if the game SOMEHOW fucks up, send the player to the title screen :)
execute if entity @p[tag=hold_pos,tag=!dead,tag=!main_menu,tag=!story_mode,tag=!title,tag=!game_state,tag=!intro_sequence,tag=!freeplay] run kill @e[type=!player,name=main_menu]
execute if entity @p[tag=hold_pos,tag=!dead,tag=!main_menu,tag=!story_mode,tag=!title,tag=!game_state,tag=!intro_sequence,tag=!freeplay] run kill @e[type=!player,name=game]
execute if entity @p[tag=hold_pos,tag=!dead,tag=!main_menu,tag=!story_mode,tag=!title,tag=!game_state,tag=!intro_sequence,tag=!freeplay] run kill @e[type=!player,name=story_mode]
execute if entity @p[tag=hold_pos,tag=!dead,tag=!main_menu,tag=!story_mode,tag=!title,tag=!game_state,tag=!intro_sequence,tag=!freeplay] run stopsound @a
execute if entity @p[tag=hold_pos,tag=!dead,tag=!main_menu,tag=!story_mode,tag=!title,tag=!game_state,tag=!intro_sequence,tag=!freeplay] run playsound fnf/menu master @a
execute if entity @p[tag=hold_pos,tag=!dead,tag=!main_menu,tag=!story_mode,tag=!title,tag=!game_state,tag=!intro_sequence,tag=!freeplay] run function fnf:title_screen

execute as @e[tag=gf_note] at @s run function fnf:gf_note

execute as @e[tag=arrow] at @s run function fnf:arrow
execute as @e[tag=hold_arrow] at @s run function fnf:arrow

execute as @a[tag=!hold_pos] run item replace entity @s armor.head with carved_pumpkin

execute as @e[tag=arrow_display] at @s run scoreboard players add @s fnf 1
execute as @e[tag=hold_display] at @s run scoreboard players add @s fnf 1

execute if entity @e[tag=game_state] if score story_mode fnf matches 0 run function fnf:tutorial_battle
execute if entity @e[tag=game_state] if score story_mode fnf matches 1 run function fnf:week1_battle
execute if entity @e[tag=game_state] if score story_mode fnf matches 2 run function fnf:week2_battle
execute if entity @e[tag=game_state] if score story_mode fnf matches 3 run function fnf:week3_battle
execute if entity @e[tag=game_state] if score story_mode fnf matches 4 run function fnf:week4_battle
execute if entity @e[tag=game_state] if score story_mode fnf matches 5 run function fnf:week5_battle
execute if entity @e[tag=game_state] if score freeplay fnf matches 0 run function fnf:freeplay_tutorial
execute if entity @e[tag=game_state] if score freeplay fnf matches 1 run function fnf:freeplay_bopeebo
execute if entity @e[tag=game_state] if score freeplay fnf matches 2 run function fnf:freeplay_fresh
execute if entity @e[tag=game_state] if score freeplay fnf matches 3 run function fnf:freeplay_dadbattle
execute if entity @e[tag=game_state] if score freeplay fnf matches 4 run function fnf:freeplay_spookeez
execute if entity @e[tag=game_state] if score freeplay fnf matches 5 run function fnf:freeplay_south
execute if entity @e[tag=game_state] if score freeplay fnf matches 6 run function fnf:freeplay_pico
execute if entity @e[tag=game_state] if score freeplay fnf matches 7 run function fnf:freeplay_philly
execute if entity @e[tag=game_state] if score freeplay fnf matches 8 run function fnf:freeplay_blammed
execute if entity @e[tag=game_state] if score freeplay fnf matches 9 run function fnf:freeplay_satin-panties
execute if entity @e[tag=game_state] if score freeplay fnf matches 10 run function fnf:freeplay_high
execute if entity @e[tag=game_state] if score freeplay fnf matches 11 run function fnf:freeplay_milf
execute if entity @e[tag=game_state] if score freeplay fnf matches 12 run function fnf:freeplay_mellohi
execute if entity @e[tag=game_state] if score freeplay fnf matches 13 run function fnf:freeplay_stal
execute if entity @e[tag=game_state] if score freeplay fnf matches 14 run function fnf:freeplay_pigstep

execute if entity @e[tag=intro_sequence] run function fnf:intro_sequence

execute as @e[tag=arrow_light] if score @s fnf matches 2 run kill @s

execute as @e[tag=arrow_light] at @s run scoreboard players add @s fnf 1
execute as @p[tag=game_state] run scoreboard players add game_timer fnf 1

execute if entity @e[tag=game_state] if score boyfriend_change fnf matches ..0 run data merge entity @e[tag=boyfriend,limit=1] {ArmorItems:[{},{},{},{Count:1,id:coarse_dirt}]}
execute if score boyfriend_change fnf matches ..0 if score a input matches 0 if score d input matches 0 if score s input matches 0 if score w input matches 0 run tag @p remove hit_note

execute as @e[tag=health_score] store result entity @s Pos[0] double 0.001 run scoreboard players get health_score fnf
tp @e[tag=health_score] @e[tag=health_score,limit=1]

# dies
execute if entity @e[tag=game_state] if score health_score fnf matches 700.. run kill @e[type=!player,name=game]
execute if entity @e[tag=game_state] if score health_score fnf matches 700.. run stopsound @a
execute if entity @e[tag=game_state] if score health_score fnf matches 700.. run function fnf:dead
execute if entity @e[tag=game_state] if score health_score fnf matches 700.. run tag @p remove game_state

# loops at 770
execute if entity @e[tag=dead] if score music_timer fnf matches 0 run playsound fnf/die master @a 0 5 0
execute if entity @e[tag=dead] if score music_timer fnf matches 0 run setblock 0 4 0 white_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 1 run setblock 0 4 0 orange_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 2 run setblock 0 4 0 magenta_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 3 run setblock 0 4 0 light_blue_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 4 run setblock 0 4 0 yellow_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 5 run setblock 0 4 0 lime_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 6 run setblock 0 4 0 pink_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 7 run setblock 0 4 0 gray_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 8 run setblock 0 4 0 light_gray_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 9 run setblock 0 4 0 cyan_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 10 run setblock 0 4 0 purple_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 11 run setblock 0 4 0 blue_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 12 run setblock 0 4 0 brown_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 13 run setblock 0 4 0 green_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 14 run setblock 0 4 0 red_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 15 run setblock 0 4 0 black_terracotta
execute if entity @e[tag=dead] if score music_timer fnf matches 16 run setblock 0 4 0 white_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 17 run setblock 0 4 0 orange_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 18 run setblock 0 4 0 magenta_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 19 run setblock 0 4 0 light_blue_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 20 run setblock 0 4 0 yellow_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 21 run setblock 0 4 0 lime_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 22 run setblock 0 4 0 pink_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 23 run setblock 0 4 0 gray_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 24 run setblock 0 4 0 light_gray_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 25 run setblock 0 4 0 cyan_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 26 run setblock 0 4 0 purple_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 27 run setblock 0 4 0 blue_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 28 run setblock 0 4 0 brown_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 29 run setblock 0 4 0 green_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 30 run setblock 0 4 0 red_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 31 run setblock 0 4 0 black_concrete
execute if entity @e[tag=dead] if score music_timer fnf matches 32 run setblock 0 4 0 white_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 33 run setblock 0 4 0 orange_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 34 run setblock 0 4 0 magenta_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 35 run setblock 0 4 0 light_blue_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 36 run setblock 0 4 0 yellow_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 37 run setblock 0 4 0 lime_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 38 run setblock 0 4 0 pink_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 39 run setblock 0 4 0 gray_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 40 run setblock 0 4 0 light_gray_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 41 run setblock 0 4 0 cyan_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 42 run setblock 0 4 0 purple_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 43 run setblock 0 4 0 blue_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 44 run setblock 0 4 0 brown_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 45 run setblock 0 4 0 green_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 46 run setblock 0 4 0 red_concrete_powder
execute if entity @e[tag=dead] if score music_timer fnf matches 47 run setblock 0 4 0 red_sand
execute if entity @e[tag=dead] if score music_timer_loop fnf matches 780.. run scoreboard players set music_timer_loop fnf 0
execute if entity @e[tag=dead] if score music_timer fnf matches 50.. if score music_timer_loop fnf matches 0 run playsound fnf/dead master @a 0 5 0
execute if entity @e[tag=dead] if score music_timer fnf matches 50.. run scoreboard players add music_timer_loop fnf 1

execute if entity @e[tag=dead] run scoreboard players add music_timer fnf 1

execute if entity @e[tag=story_mode] if score music_timer_loop fnf matches 2260.. run scoreboard players set music_timer_loop fnf 0
execute if entity @e[tag=main_menu] if score music_timer_loop fnf matches 2260.. run scoreboard players set music_timer_loop fnf 0
execute if entity @e[tag=freeplay] if score music_timer_loop fnf matches 2260.. run scoreboard players set music_timer_loop fnf 0
execute if entity @e[tag=title] if score music_timer_loop fnf matches 2260.. run scoreboard players set music_timer_loop fnf 0

execute if entity @e[tag=story_mode] if score music_timer_loop fnf matches 0 run playsound fnf/menu master @a 0 5 0
execute if entity @e[tag=main_menu] if score music_timer_loop fnf matches 0 run playsound fnf/menu master @a 0 5 0
execute if entity @e[tag=freeplay] if score music_timer_loop fnf matches 0 run playsound fnf/menu master @a 0 5 0
execute if entity @e[tag=title] if score music_timer_loop fnf matches 0 run playsound fnf/menu master @a 0 5 0

execute if entity @e[tag=story_mode] run scoreboard players add music_timer_loop fnf 1
execute if entity @e[tag=main_menu] run scoreboard players add music_timer_loop fnf 1
execute if entity @e[tag=freeplay] run scoreboard players add music_timer_loop fnf 1
execute if entity @e[tag=title] run scoreboard players add music_timer_loop fnf 1

scoreboard players remove boyfriend_change fnf 1
scoreboard players remove opponent_change fnf 1

execute as @p[tag=!running] run kill @e[type=item]
